using System ;

[Serializable]
public class Network{

	public string SSID=null, MAC, Channel, Rate, Signal="0", Caps, INT;
	public string wep,ip,method,netmask,gateway;

	public Network(){}

	public Network(string[] data){

		if (data.Length<6)
			return;

		SSID    = data[0];
		MAC     = data[1];
		Channel = data[2];
		Rate    = data[3];
		Signal  = data[4];
		Caps    = data[5];

	}
	public bool IsOnline{
		get { return  Int32.Parse(Signal)>0 ; }
	}
	public bool IsRouter{
		get { return (bool) (Caps.IndexOf("E")>-1); }
	}
	public bool IsEncripted{
		get { return (bool) ( (bool)(Caps.IndexOf("P")>-1) ||(bool)(Caps.IndexOf("B")>-1) ) ; }
	}
	public override string  ToString(){
		return String.Format("WireLess\t{0}:\n\tmac: {1}\n\tch: {2}\n\t rate:{3}\n\tsignal:{4}\n\tcaps:{5}\nip:{6}",SSID, MAC, Channel, Rate, Signal, Caps,ip);
	}
	public override bool Equals(object o){
		Network no = (Network) o;
		return this.SSID==no.SSID 
			&& this.Caps==no.Caps 
			&& this.Channel== no.Channel 
			&& this.INT == no.INT
			&& this.MAC == no.MAC
			&& this.Rate == no.Rate
			&& this.Signal == no.Signal ;
	}

}
