using System;
using System.Collections;

using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

[Serializable]
public class Networks {

	public Hashtable list;
	
	public Networks(){
		list = new Hashtable();
	}
	public Network this[string key] {	
		get { return (Network) list[key] ; }
		set {  list[key]=value; }	
	}
	public void Add(Network o){
		list.Add(o.SSID,o);	
	}
	public void Remove(string ssid){
		list.Remove(ssid);	
	}
	public bool Exist(string key){
		return list[key]!=null; 
	}
	public bool Exist(Network o){
		 return Exist(o.SSID);
	}
	public int Total{
		get { return list.Count; }
	}
	public void UpdateNetInfoFrom(Network net){
		this[net.SSID].SSID=net.SSID;
		this[net.SSID].MAC=net.MAC;
		this[net.SSID].Channel=net.Channel;
		this[net.SSID].Rate=net.Rate;
		this[net.SSID].Signal=net.Signal;
		this[net.SSID].Caps=net.Caps;
		this[net.SSID].INT=net.INT;
	}
	
	public int TotalOnline{
		get {
			int i=0;
			foreach (Network n in list.Values)
				if (n.IsOnline)
					i++	;		
			return i;
		}
	}
	public int TotalEncripted{
		get {
			int i=0;
			foreach (Network n in list.Values)
				if (n.IsEncripted)
					i++;
			return i;
		}
	}
	public string[] All{
		get {
			//too ugly?
			string[] tmp =  new string[list.Count]; 
			int i=0;
			foreach (string k in list.Keys){
				tmp[i] = (string) k;
				i++;
			}
			return tmp;
		}
	}
	public void SaveTo(string FileName){
		FileStream fs = new FileStream(FileName, FileMode.OpenOrCreate, FileAccess.Write);
		BinaryFormatter bf = new BinaryFormatter();
		bf.Serialize(fs, this);
		fs.Close();
	}
	public static Networks LoadFrom(string FileName){
		FileStream fs = new FileStream(FileName, FileMode.Open);
		BinaryFormatter bf = new BinaryFormatter();
		Networks tmp = (Networks) bf.Deserialize(fs);
		fs.Close();
		
		//There are offline for now..
		foreach (Network n in tmp.list.Values)
			n.Signal="0";
		
		return tmp;
		
	}
	public void AllOffline(){
		foreach (Network n in list.Values)
			n.Signal="0";
	}
	
	

}
